Description

Especially external components, such as
1. etcd

2. netbox

3. otp.ungleich.ch

Related issues:
Related to Open Infrastructure - Task #7583: Handle etcd leader change or tem...

Rejected

01/07/2020

History

#1 - 01/09/2020 08:48 AM - Ahmed Bilal

How do we plan to handle failures in etcd

Failures can be temporarily (leadership change) or permanent (etcd cluster dies)
We use four type of functions of etcd

1. get

2. put

3. get_prefix
4. watch_prefix

get
can output the following:

e EtcdEntry
e Exception (KeyError if key not found, and a pleothera of other depending on situations)

TODO: KeyError is recently introduced so would require us to handle it in all stretches of uncloud other errors are also not handled.

TODO: Handle Exception thrown by get.
put
can output the following:

¢ Response from etcd library
e Exception

TODO: See whether the response from etcd library has success/failure indication.
TODO: Handle exception in case something goes wrong.

get_prefix
can output/yield the following:

e EtcdEntry
e Exception

TODO: Handle exception in case something goes wrong.
watch_prefix
can output/yield the following:

e EtcdEntry
e an empty iter in case of exception

#2 - 01/09/2020 08:52 AM - Ahmed Bilal
- Related to Task #7583: Handle etcd leader change or temporary unavailability gracefully in uncloud added

#3 - 01/09/2020 08:55 AM - Ahmed Bilal

| am little uncertain how to handle failures in etcd. For Example, put every etcd function call in try/except block or do something else.

#4 - 12/01/2020 02:49 PM - Ahmed Bilal
- Assignee deleted (Ahmed Bilal)

#5 - 12/06/2021 11:54 PM - Nico Schottelius

- Status changed from New to Rejected
